DAQInterface appears to leak file descriptors
Description

From Eric:

"DAQInterface appears to leak file descriptors (possibly handles to per-run log files?)...I did 297 runs in one instance, and it failed to
boot after due to a "too many open files" error. "

Associated revisions

Revision e05a76e4 - 09/15/2018 08:13 PM - John Freeman

JCF: The cut-and-pasted deepsuppression context manager | got from
stackoverflow.com back in 2014 had a bug, in that it wasn't closing

all file descriptors in exit. Whenever it was called by

DAQInterface, it was leaking file descriptors, a problem observed by
Eric in Issue #20757. This commit properly closes the file

descriptors.

History

#1 - 09/06/2018 12:10 PM - John Freeman

- Assignee set to John Freeman

#2 - 09/07/2018 07:43 AM - Eric Flumerfelt
- File daginterface_Isof.log added
- File daginterface_fds.log added

I made another long-running instance, and there's a large number of PIPEs, apparently between two threads within DAQInterface. | have captured the
output of Isof into a log file, as well as the output of Is - /proc/<PID>/fd.

#3 - 09/07/2018 03:51 PM - Eric Flumerfelt

After a bit more testing, it appears that the leak happens on Terminate-Boot cycles, not Stop-Start cycles.

#4 - 09/15/2018 08:19 PM - John Freeman
- Status changed from New to Resolved

- % Done changed from 0 to 100

Solved with commit e05a76e400de3ba1382f8424c9cf2f333179d717. I'll just quote the commit comments:

JCF: The cut-and-pasted deepsuppression context manager | got from stackoverflow.com back in 2014 had

a bug, in that it wasn't closing all file descriptors in deepsuppression.__exit__. Whenever deepsuppression() was called by DAQInterface, it was
leaking file descriptors, a problem observed by Eric in Issue #20757. This commit properly closes the file

descriptors.

Files
daginterface_lsof.log 237 KB 09/07/2018 Eric Flumerfelt
daginterface_fds.log 58.1 KB 09/07/2018 Eric Flumerfelt
